// ignore_for_file: duplicate_import, unused_import, unnecessary_null_comparison, unnecessary_non_null_assertion

/// DO NOT EDIT THIS FILE.  IT IS GENERATED AUTOMATICALLY AND YOUR CHANGES WILL BE OVERWRITTEN

import 'dart:convert';
import 'package:sunny_sdk_core/api_exports.dart';

import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import '../model/book_club.dart';
import '../model/book_club_list.dart';

import '../mixins/facts.dart';
import '../facts.dart';

/// DO NOT EDIT THIS FILE.  TO ADJUST THIS CLASS, USE [ BookClubApiMixin ]
///
/// The final API is constructed by:
///
/// * taking the [BookClubApiBase] class
/// * applying a mixin [ BookClubApiMixin ]] (which allows us to inject other convenience functions)
///      The mixin lives outside of the code generator, so it's used to do any manual tweaking
/// * Applying the [SignalingApiMixin], so events automatically propagate
///
class BookClubApi extends SunnyApi<IBookClub>
    with SignalingApiMixin<IBookClub>
    implements IBookClubApi {
  final ApiClient apiClient;

  BookClubApi(this.apiClient, ApiRegistry apis)
      : super(apis, ([json]) => BookClub.fromJson(json ?? <String, dynamic>{}));
  @override
  MSchemaRef get mtype => BookClubRef;

  // ignore: avoid_renaming_method_parameters
  Future<IBookClub> create(
    IBookClub bookClub,
  ) async {
    final builder = RequestBuilder();
    builder.body = bookClub;
    if (bookClub == null) {
      throw BadRequestException.singleField(
        "bookClub",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/bookClub";
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.POST;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IBookClub.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<DeleteResponse> delete(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/bookClub/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.DELETE;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return DeleteResponse.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IBookClubList> list({double? limit, double? offset}) async {
    final builder = RequestBuilder();
    builder.body = null;
    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/bookClub";
    builder.queryParams["limit"] = limit;
    builder.queryParams["offset"] = offset;
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IBookClubList.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IBookClub> load(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/bookClub/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IBookClub.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<ChangeResult> update(
    String id,
    IBookClub bookClub,
  ) async {
    final builder = RequestBuilder();
    builder.body = bookClub;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }
    if (bookClub == null) {
      throw BadRequestException.singleField(
        "bookClub",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/bookClub/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.PUT;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return value as ChangeResult;
  }
}
