// ignore_for_file: duplicate_import, unused_import, unnecessary_null_comparison, unnecessary_non_null_assertion

/// DO NOT EDIT THIS FILE.  IT IS GENERATED AUTOMATICALLY AND YOUR CHANGES WILL BE OVERWRITTEN

import 'dart:convert';
import 'package:sunny_sdk_core/api_exports.dart';

import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import '../model/fact.dart';
import '../model/fact_list.dart';
import '../model/facts.dart';

import '../mixins/facts.dart';
import '../facts.dart';

/// DO NOT EDIT THIS FILE.  TO ADJUST THIS CLASS, USE [ FactApiMixin ]
///
/// The final API is constructed by:
///
/// * taking the [FactApiBase] class
/// * applying a mixin [ FactApiMixin ]] (which allows us to inject other convenience functions)
///      The mixin lives outside of the code generator, so it's used to do any manual tweaking
/// * Applying the [SignalingApiMixin], so events automatically propagate
///
class FactApi extends SunnyApi<IFact>
    with SignalingApiMixin<IFact>
    implements IFactApi {
  final ApiClient apiClient;

  FactApi(this.apiClient, ApiRegistry apis)
      : super(apis, ([json]) => Fact.fromJson(json ?? <String, dynamic>{}));
  @override
  MSchemaRef get mtype => FactRef;

  // ignore: avoid_renaming_method_parameters
  Future<IFact> create(
    IFact fact,
  ) async {
    final builder = RequestBuilder();
    builder.body = fact;
    if (fact == null) {
      throw BadRequestException.singleField(
        "fact",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/fact";
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.POST;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IFact.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<DeleteResponse> delete(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/fact/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.DELETE;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return DeleteResponse.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IFacts> factsByRecordKey({String? recordKey}) async {
    final builder = RequestBuilder();
    builder.body = null;
    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/factsByRecordKey";
    builder.queryParams["recordKey"] = recordKey;
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IFacts.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IFactList> list({double? limit, double? offset}) async {
    final builder = RequestBuilder();
    builder.body = null;
    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/fact";
    builder.queryParams["limit"] = limit;
    builder.queryParams["offset"] = offset;
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IFactList.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IFact> load(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/fact/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IFact.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<ChangeResult> update(
    String id,
    IFact fact,
  ) async {
    final builder = RequestBuilder();
    builder.body = fact;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }
    if (fact == null) {
      throw BadRequestException.singleField(
        "fact",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/fact/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.PUT;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return value as ChangeResult;
  }
}
