// ignore_for_file: duplicate_import, unused_import, unnecessary_null_comparison, unnecessary_non_null_assertion

/// DO NOT EDIT THIS FILE.  IT IS GENERATED AUTOMATICALLY AND YOUR CHANGES WILL BE OVERWRITTEN

import 'dart:convert';
import 'package:sunny_sdk_core/api_exports.dart';

import 'package:sunny_sdk_core/sunny_sdk_core.dart';
import '../model/remember.dart';
import '../model/remember_list.dart';

import '../mixins/facts.dart';
import '../facts.dart';

/// DO NOT EDIT THIS FILE.  TO ADJUST THIS CLASS, USE [ RememberApiMixin ]
///
/// The final API is constructed by:
///
/// * taking the [RememberApiBase] class
/// * applying a mixin [ RememberApiMixin ]] (which allows us to inject other convenience functions)
///      The mixin lives outside of the code generator, so it's used to do any manual tweaking
/// * Applying the [SignalingApiMixin], so events automatically propagate
///
class RememberApi extends SunnyApi<IRemember>
    with SignalingApiMixin<IRemember>
    implements IRememberApi {
  final ApiClient apiClient;

  RememberApi(this.apiClient, ApiRegistry apis)
      : super(apis, ([json]) => Remember.fromJson(json ?? <String, dynamic>{}));
  @override
  MSchemaRef get mtype => RememberRef;

  // ignore: avoid_renaming_method_parameters
  Future<IRemember> create(
    IRemember remember,
  ) async {
    final builder = RequestBuilder();
    builder.body = remember;
    if (remember == null) {
      throw BadRequestException.singleField(
        "remember",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/remember";
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.POST;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IRemember.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<DeleteResponse> delete(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/remember/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.DELETE;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return DeleteResponse.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IRememberList> list({double? limit, double? offset}) async {
    final builder = RequestBuilder();
    builder.body = null;
    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/remember";
    builder.queryParams["limit"] = limit;
    builder.queryParams["offset"] = offset;
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IRememberList.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<IRemember> load(
    String id,
  ) async {
    final builder = RequestBuilder();
    builder.body = null;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/remember/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.GET;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return IRemember.fromJson(value);
  }

  // ignore: avoid_renaming_method_parameters
  Future<ChangeResult> update(
    String id,
    IRemember remember,
  ) async {
    final builder = RequestBuilder();
    builder.body = remember;
    if (id == null) {
      throw BadRequestException.singleField(
        "id",
        "Missing required request parameter",
        keyword: "required",
      );
    }
    if (remember == null) {
      throw BadRequestException.singleField(
        "remember",
        "Missing required request parameter",
        keyword: "required",
      );
    }

    // create path and map variables
    // create path and map variables
    builder.path = "/sunny/0.0.1/fact/remember/{id}";
    builder.pathParams["id"] = Uri.encodeComponent(id);
    List<String> contentTypes = [];
    String contentType =
        contentTypes.isNotEmpty ? contentTypes[0] : "application/json";
    builder.contentType = contentType;
    builder.basePath = apiClient.basePaths["facts"];
    builder.method = HttpMethod.PUT;

    final response = await apiClient.invokeRequest(builder);
    final value = json.decode(response.body);
    return value as ChangeResult;
  }
}
