import 'package:facts/mixins/facts.dart';
import 'package:sunny_dart/sunny_get.dart';

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_sdk_core/services.dart';
import 'package:sunny_service_stubs/sunny_service_stubs.dart';
export 'package:sunny_service_stubs/meta.dart';

extension MKeyUserExt on MKey? {
  bool get isUserKey => this != null && this == sunny.get<IUserProfile>().mkey;

//  /// Determines whether a key is related to a contact as:
//  /// the contact's key
//  /// the user's key
//  /// another contact's key
  ContactLinkType? linkType(IRef subject) {
    if (isUserKey) return ContactLinkType.user;
    if (this?.mxid == subject.id) return ContactLinkType.contact;
    return this == null ? null : ContactLinkType.other;
  }
}
